extends CharacterBody3D

@onready var MainScene = get_tree().current_scene
const BulletClass = preload("res://Units/enemy_bullet.tscn")
const LightningTrapClass = preload("res://lightning_trap.tscn")
const EnemyClass = preload("res://Units/enemy.tscn")
const Explosion = preload("res://enemy_explosion.tscn")
var BossStage : int = 0
var Active = false
var move : float = 1.6
var move2 : float = 0.0
var Speed : float = 1.7
var SpecialMoveTimer : float = 0.0
var SpecialMoveCounter01 : float = 0.0
var SpecialMoveCounter02 : float = 0.0
var SpecialMoveCounter03 : float = 0.0
var SpecialMoveBool01 : bool = false
var SpecialMoveBool02 : bool = false
var Invincible : bool = false
var SkeletonPartsDestroyedCounter : int = 0
var Shoot_timer = 0.0
var LightningTrapTimer = 0.0
var Wait : float = 0.0
var SpecialMove : bool = false
var X : float = 0.0
var Y : float = 0.0
var FinalStage : bool = false
var HPFinal = 1000
var whichSpecialMove : int = 0
var Dead = false
var timeout = 0.0

@onready var Anim = $AnimationPlayer
@onready var Anim2 = $AnimationPlayer2
@onready var Anim3 = $AnimationPlayer3
@onready var Anim4 = $AnimationPlayer4
@onready var PeonAnim = $PeonAnimation
@onready var PeonAnim2 = $PeonAnimation2
var SkeletHealthPart1 : float = 400.0
var SkeletHealthPart2 : float = 200.0
var SkeletHealthPart3 : float = 400.0
var SkeletHealthPart4 : float = 400.0

func onSkeletonPartDestroyed():
	SkeletonPartsDestroyedCounter += 1
	if SkeletonPartsDestroyedCounter >= 4:
		BossStage = 2
		MainScene.PlayerDamage = 6.0
		$Armature/Skeleton3D/peon_portrait/peon.monitoring = true
		MainScene.partsHP.visible = false
		MainScene.peonHP.visible = true
		MainScene.peonHP.get_node("ProgressBar").modulate = Color(0.0, 1.0, 0.0, 1.0)
		var t = get_tree().create_tween()
		t.tween_property(MainScene.peonHP.get_node("ProgressBar"), "value", 700.0, 1.0).set_trans(Tween.TRANS_SINE)
		t = null

func _ready():
	#connection
	$Armature/Skeleton3D/Plane/Area3D.connect("PartDestroyed", onSkeletonPartDestroyed)
	$Armature/Skeleton3D/Plane001/Area3D.connect("PartDestroyed", onSkeletonPartDestroyed)
	$Armature/Skeleton3D/Plane002/Area3D.connect("PartDestroyed", onSkeletonPartDestroyed)
	$Armature/Skeleton3D/Plane003/Area3D.connect("PartDestroyed", onSkeletonPartDestroyed)
	transform.origin = Vector3(-30.0, 5.0, 0.0)
	var t = get_tree().create_tween()
	t.tween_property(self, "position", Vector3(0.0, 0.0, -120.0), 5.5).set_trans(Tween.TRANS_ELASTIC)
	t.tween_callback(activate)
	t = null

func activate():
	Active = true

func Shoot(bullet_speed):
	var bullet = BulletClass.instantiate()
	MainScene.add_child(bullet)
	bullet.transform.origin = transform.origin
	bullet.velocity = transform.origin.direction_to(MainScene.Player.transform.origin)* bullet_speed
	bullet = null

func BossStage01 (delta):
	#move
	move += delta
	transform.origin.x = move_toward(transform.origin.x, cos(move) * 120.0, Speed)
	var rot_speed = clamp(-transform.origin.x * 2.0, -35.0, 35.0)
	rotation_degrees.y = move_toward(rotation_degrees.y, rot_speed, 1.1)

	Shoot_timer += delta
	if Shoot_timer >= 1.3:
		Shoot_timer = 0.0
		var bullet = BulletClass.instantiate()
		MainScene.add_child(bullet)
		bullet.transform.origin = transform.origin
		bullet.velocity = transform.origin.direction_to(MainScene.Player.transform.origin)* 120
		bullet = null

	if move >= 10.0:
		BossStage = 1

func BossStage02 (delta):
	#move
	move2 += delta
	move += delta
	X = transform.origin.x
	Y = transform.origin.y
	
	if !SpecialMove:
		SpecialMoveTimer += delta
		transform.origin.x = move_toward(X, cos(move) * 120.0, Speed)
		transform.origin.y = move_toward(Y, sin(move2) * 55.0, Speed)
		Shoot_timer += delta
		if Shoot_timer >= 1.3:
			Shoot_timer = 0.0
			Shoot(120)
	
	if SpecialMoveTimer >= 10.0:
		SpecialMoveTimer = 0.0
		SpecialMove = true
		var t = get_tree().create_tween()
		t.tween_property(self, "position", Vector3(0.0, 0.0, -80.0), 1.0).set_trans(Tween.TRANS_QUAD)
	if SpecialMove:
		SpecialMove01(delta)
	var rot_speed = clamp(-transform.origin.x * 5.0, -50.0, 50.0)
	rotation_degrees.y = move_toward(rotation_degrees.y, rot_speed, 2.1)

func SpecialMove01(delta):
	Wait += delta
	if Wait < 0.9:
		return
	SpecialMoveCounter01 += delta
	if SpecialMoveCounter01 >= 0.1:
		SpecialMoveCounter01 = 0.0
		SpecialMoveCounter02 += 1
		Shoot(200)
	if SpecialMoveCounter02 >= 15:
		SpecialMoveCounter01 = 0.0
		SpecialMoveCounter02 = 0.0
		Wait = 0.0
		var t = get_tree().create_tween()
		t.tween_property(self, "position", Vector3(X, Y, -120.0), 1.0).set_trans(Tween.TRANS_QUAD)
		SpecialMove = false
		PeonAnim2.play("MouthClose")

func BossStage03 (delta):
	#move
	move2 += delta
	move += delta
	X = transform.origin.x
	Y = transform.origin.y
	if !SpecialMove:
		LightningTrapTimer += delta
		SpecialMoveTimer += delta
		transform.origin.x = move_toward(X, cos(move) * 120.0, Speed)
		transform.origin.y = move_toward(Y, sin(move2) * 55.0, Speed)
		Shoot_timer += delta
		if Shoot_timer >= 1.0:
			Shoot_timer = 0.0
			Shoot(randf_range(150.0, 250.0))
		if LightningTrapTimer >= 5.0:
			LightningTrapTimer = 0.0
			var trap = LightningTrapClass.instantiate()
			MainScene.add_child(trap)
			trap.rotation.z = randf_range(0.0, 360.0)
			trap.transform.origin = transform.origin
			trap.Speed = 30.0
			var t = get_tree().create_tween()
			t.tween_property(trap, "position", Vector3(0.0, 0.0, -110.0), 1.05).set_trans(Tween.TRANS_CUBIC)
			t.tween_callback(trap.onStart)
			trap = null
	if SpecialMoveTimer >= 10.0:
		SpecialMoveTimer = 0.0
		SpecialMove = true
		PeonAnim2.play("MouthOpen")
		var t = get_tree().create_tween()
		t.tween_property(self, "position", Vector3(-100.0, 0.0, -120.0), 1.0).set_trans(Tween.TRANS_QUAD)
		t.tween_property(self, "position", Vector3(100.0, 0.0, -120.0), 3.0).set_trans(Tween.TRANS_SINE)
	if SpecialMove:
		SpecialMove02(delta)
	var rot_speed = clamp(-transform.origin.x * 5.0, -50.0, 50.0)
	rotation_degrees.y = move_toward(rotation_degrees.y, rot_speed, 2.1)

func SpecialMove02(delta):
	Wait += delta
	if Wait >= 0.9:
		SpecialMoveBool01 = true
	if SpecialMoveBool01:
		SpecialMoveCounter01 += delta
		SpecialMoveCounter02 += delta
		if SpecialMoveCounter01 >= 0.1:
			SpecialMoveCounter01 = 0.0
			var missile_count = randi_range(3, 7)
			for i in missile_count:
				var offset = 5.0
				var missile_speed = randf_range( 150.0, 180.0)
				var bullet = BulletClass.instantiate()
				MainScene.add_child(bullet)
				bullet.transform = global_transform
				bullet.velocity = transform.origin.direction_to(\
					Vector3(MainScene.Player.position.x + randf_range(-offset, offset),\
					MainScene.Player.position.y + randf_range(-offset, offset),\
					MainScene.Player.position.z ))* missile_speed
		if SpecialMoveCounter02 >= 3.0:
			SpecialMoveCounter01 = 0.0
			SpecialMoveCounter02 = 0.0
			Wait = 0.0
			var t = get_tree().create_tween()
			t.tween_property(self, "position", Vector3(X, Y, -120.0), 1.0).set_trans(Tween.TRANS_QUAD)
			SpecialMove = false
			SpecialMoveBool01 = false
			PeonAnim2.play("MouthClose")

func BossStage04 (delta):
	#move
	var rot_speed = clamp(-transform.origin.x * 5.0, -50.0, 50.0)
	rotation_degrees.y = move_toward(rotation_degrees.y, rot_speed, 2.1)
	if Dead:
		timeout += delta
		if timeout >= 5.0:
			for i in 5:
				var boom = Explosion.instantiate()
				boom.scale *= 25.0
				MainScene.add_child(boom)
				boom.transform = transform
			queue_free()
			MainScene.victory()
		
		
		return
	if !FinalStage: 
		X = 0.0
		Y = 0.0
	if FinalStage: 
		if !SpecialMove:
			move2 += delta
			move += delta
			X = transform.origin.x
			Y = transform.origin.y
			transform.origin.x = move_toward(X, sin(move) * 120.0, Speed)
			transform.origin.y = move_toward(Y, sin(move2) * 55.0, Speed)
			Shoot_timer += delta
			if Shoot_timer >= 1.0:
				Shoot_timer = 0.0
				var missile_count = randi_range(10, 15)
				for i in missile_count:
					var offset = 5.0
					var missile_speed = randf_range( 150.0, 180.0)
					var bullet = BulletClass.instantiate()
					MainScene.add_child(bullet)
					bullet.transform = global_transform
					bullet.velocity = transform.origin.direction_to(\
						Vector3(MainScene.Player.position.x + randf_range(-offset, offset),\
						MainScene.Player.position.y + randf_range(-offset, offset),\
						MainScene.Player.position.z ))* missile_speed


			SpecialMoveTimer += delta
			if SpecialMoveTimer >= 10.0:
				SpecialMoveTimer = 0.0
				whichSpecialMove = randi_range(0,1)
				match whichSpecialMove:
					0:
						SpecialMove = true
						SpecialMoveCounter01 = 0.0
						SpecialMoveCounter02 = 0.0
						SpecialMoveCounter03 = 0.0
						Wait = 0.0
						PeonAnim.play("MouthOpen")
						var t = get_tree().create_tween()
						t.tween_property(self, "position", Vector3(100.0, 0.0, -90.0), 1.0).set_trans(Tween.TRANS_QUAD)
						t.tween_property(self, "position", Vector3(-100.0, 0.0, -90.0), 1.0).set_trans(Tween.TRANS_SINE)
					1:
						SpecialMove = true
						SpecialMoveCounter01 = 0.0
						SpecialMoveCounter02 = 0.0
						SpecialMoveCounter03 = 0.0
						Wait = 0.0
						PeonAnim.play("MouthOpen")
						var t = get_tree().create_tween()
						t.tween_property(self, "position", Vector3(-100.0, 0.0, -60.0), 1.0).set_trans(Tween.TRANS_QUAD)
						t.tween_property(self, "position", Vector3(100.0, 0.0, -60.0), 3.0).set_trans(Tween.TRANS_SINE)
		if SpecialMove:
			match whichSpecialMove:
				0:
					FinalSpecialMove01(delta)
				1: 
					FinalSpecialMove02(delta)

func FinalSpecialMove01(delta):
	Wait += delta
	if Wait >= 0.9:
		SpecialMoveBool01 = true
	if SpecialMoveBool01:
		SpecialMoveCounter01 += delta
		SpecialMoveCounter02 += delta
		if SpecialMoveCounter01 >= 0.5 and !SpecialMoveBool02:
			SpecialMoveBool02 = true
			
			for i in 4:
				SpecialMoveCounter03 += 20.0
				var trap = LightningTrapClass.instantiate()
				MainScene.add_child(trap)
				trap.rotation.z = SpecialMoveCounter03
				trap.transform.origin = transform.origin
				trap.Speed = 30.0
				var t = get_tree().create_tween()
				t.tween_property(trap, "position", Vector3(0.0, 0.0, -90.0), 0.85).set_trans(Tween.TRANS_CUBIC)
				t.tween_callback(trap.onStart)
				trap = null
		if SpecialMoveCounter02 >= 1.0:
			
			SpecialMoveCounter01 = 0.0
			SpecialMoveCounter02 = 0.0
			SpecialMoveCounter03 = 0.0
			Wait = 0.0
			var t = get_tree().create_tween()
			t.tween_property(self, "position", Vector3(X, Y, -120.0), 1.0).set_trans(Tween.TRANS_QUAD)
			SpecialMove = false
			SpecialMoveBool01 = false
			SpecialMoveBool02 = false
			PeonAnim.play("MouthClose")

func FinalSpecialMove02(delta):
	Wait += delta
	if Wait >= 0.9:
		SpecialMoveBool01 = true
	if SpecialMoveBool01:
		SpecialMoveCounter01 += delta
		SpecialMoveCounter02 += delta
		if SpecialMoveCounter01 >= 0.1:
			SpecialMoveCounter01 = 0.0
			for i in 4:
				var peon = EnemyClass.instantiate()
				MainScene.add_child(peon)
				peon.transform.origin = transform.origin
				peon.velocity = transform.origin.direction_to(MainScene.Player.transform.origin)* 40.0

		if SpecialMoveCounter02 >= 3.0:
			SpecialMoveCounter01 = 0.0
			SpecialMoveCounter02 = 0.0
			SpecialMoveCounter03 = 0.0
			Wait = 0.0
			var t = get_tree().create_tween()
			t.tween_property(self, "position", Vector3(X, Y, -120.0), 1.0).set_trans(Tween.TRANS_QUAD)
			SpecialMove = false
			SpecialMoveBool01 = false
			SpecialMoveBool02 = false
			PeonAnim.play("MouthClose")

func _process(delta):
	if !Active:
		return
	match BossStage:
		0:
			BossStage01 (delta)
		1:
			BossStage02 (delta)
		2:
			BossStage03 (delta)
		3:
			BossStage04 (delta)
