extends Node3D

@onready var bg = $WorldEnvironment
@onready var Spaceship = preload("res://Units/player.tscn")
@onready var GameOverScreen = preload("res://game_over.tscn")
@onready var StartText = preload("res://start_text.tscn")
@onready var partsHP = $UI/BossHealthBars
@onready var hp1 = $UI/BossHealthBars/ProgressBar
@onready var hp2 = $UI/BossHealthBars/ProgressBar2
@onready var hp3 = $UI/BossHealthBars/ProgressBar3
@onready var hp4 = $UI/BossHealthBars/ProgressBar4
@onready var peonHP = $UI/PeonHP
var bg_rotation = Vector3.ZERO
var Player
var Boss
var PlayerLifeCount = 4
var GameOver = false
var Victory = false
var Score = 0
const MaxScore = 1000
var PlayerDamage = 5


func _ready():
	Player = Spaceship.instantiate()
	add_child(Player)
	Player.connect("Crush", on_Player_Crushed)
	$UI/MarginContainer/PlayerLifes/LifeCount.text = str(PlayerLifeCount)
	$UI/MarginContainer/PlayerScore/Score.text = str(Score)
	var text = StartText.instantiate()
	$UI.add_child(text)
	text.get_node("AnimationPlayer").play("StartText")

func _process(delta):
	bg_rotation += Vector3(0.003, 0.018, 0.008)*delta
	bg.environment.sky_rotation = bg_rotation

func on_Player_Crushed():
	PlayerLifeCount -= 1
	$UI/MarginContainer/PlayerLifes/LifeCount.text = str(PlayerLifeCount)
	if PlayerLifeCount <= 0 and !GameOver:
		GameOver = true
		$BGM.playing = false
		var gos = GameOverScreen.instantiate()
		$UI.add_child(gos)
		gos.get_node("AnimationPlayer").play("GameOver")

func handle_enemy_connection(enemy):
	enemy.connect("EnemyDestroyed", on_score_update)

func on_score_update(score):
	pass
	#Score = min(Score + score, MaxScore)
	#$UI/MarginContainer/PlayerScore/Score.text = str(Score)
	#if Score >= MaxScore and !Victory:
	#	victory()

func victory():
	Victory = true
	get_tree().call_group("ENEMIES", "on_destroy")
	Player.get_node("HitBox/CollisionShape3D").disabled = true
	var gos = GameOverScreen.instantiate()
	$UI.add_child(gos)
	gos.get_node("Label").text = "ПОБЕДА!"
	gos.get_node("AudioStreamPlayer").playing = false
	gos.get_node("AnimationPlayer").play("GameOver")
