extends Area3D
@onready var MainScene = get_tree().current_scene
const CrushEffect = preload("res://player_crushed.tscn")
var Destroyed = false
var HP = 700.0


# Called when the node enters the scene tree for the first time.
func _ready():
	pass # Replace with function body.


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	pass

func calculateHP():
	var red = 1.0 - (MainScene.peonHP.get_node("ProgressBar").value / MainScene.peonHP.get_node("ProgressBar").max_value)
	if !MainScene.Boss.FinalStage:
		MainScene.peonHP.get_node("ProgressBar").value = HP
	else:
		MainScene.peonHP.get_node("ProgressBar").value = MainScene.Boss.HPFinal
	MainScene.peonHP.get_node("ProgressBar").modulate = Color(red, 1.0 - red, 0.0, 1.0)

func get_hit():
	if !MainScene.Boss.FinalStage:
		if Destroyed:
			return
		MainScene.Boss.PeonAnim.stop()
		MainScene.Boss.PeonAnim.play("PeonHit")
		HP -= MainScene.PlayerDamage
		calculateHP()
		if HP <= 0.0:
			Destroyed = true
			MainScene.Boss.SpecialMove = false
			MainScene.Boss.BossStage = 3
			var t = get_tree().create_tween()
			t.tween_property(MainScene.Boss, "position", Vector3(0.0, 0.0, -120.0), 1.0).set_trans(Tween.TRANS_QUAD)
			MainScene.peonHP.get_node("ProgressBar").max_value = MainScene.Boss.HPFinal
			MainScene.peonHP.get_node("ProgressBar").modulate = Color(0.0, 1.0, 0.0, 1.0)
			t.tween_property(MainScene.peonHP.get_node("ProgressBar"), "value", MainScene.Boss.HPFinal, 1.0).set_trans(Tween.TRANS_SINE)
			MainScene.Boss.Invincible = true
			MainScene.Boss.PeonAnim2.stop()
			MainScene.Boss.PeonAnim.stop()
			MainScene.Boss.PeonAnim2.play("FinalStage")
			
			await MainScene.Boss.PeonAnim2.animation_finished
			MainScene.Boss.Invincible = false
			MainScene.Boss.FinalStage = true

	if MainScene.Boss.FinalStage:
		if !MainScene.Boss.Invincible:
			MainScene.Boss.PeonAnim2.stop()
			MainScene.Boss.PeonAnim2.play("PeonHit_FinalStage")
			MainScene.Boss.HPFinal -= MainScene.PlayerDamage
			calculateHP()
			if MainScene.Boss.HPFinal <= 0.0:
				MainScene.Boss.Invincible = true
				MainScene.Boss.Dead = true
				var CrushSFX = CrushEffect.instantiate()
				CrushSFX.scale *= 5.0
				MainScene.Boss.add_child(CrushSFX)
				
				var t = get_tree().create_tween()
				t.tween_property(MainScene.Boss, "position", Vector3(0.0, 0.0, -120.0), 1.0).set_trans(Tween.TRANS_QUAD)
				MainScene.Boss.PeonAnim2.play("death")	

func _on_body_entered(body):
	body.queue_free()
	get_hit()
